#include "config.h"
#include "system.h"
#include "rtl.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"
#include "conditions.h"
#include "insn-attr.h"
#include "flags.h"
#include "recog.h"
#include "tree.h"
#include "output.h"
#include "expr.h"
#include "obstack.h"
#include "except.h"
#include "function.h"
#include "tm_p.h"
#include "target.h"
#include "target-def.h"

int c33_num_arg_regs(int int_mode, tree type);
void c33_print_operand(FILE* fp,  rtx x, int code);
void c33_print_operand_address(FILE* fp, rtx addr);
void c33_expand_prologue(void);
void c33_expand_epilogue(void);
int c33_initial_offset(int from, int to);

// TARGET_INITIALIZER̒ŎgĂ݂B
// ftHgł HI_OP=.short SI_OP=.long ƒ`Ă邪A
// C33MIPS  HI_OP=.half  SI_OP=.word Ȃ̂ŁA`ȂB
// x[XɂFR30ł܂܍Ē`Ă̂ŋCt܂B
#undef TARGET_ASM_ALIGNED_HI_OP
#define TARGET_ASM_ALIGNED_HI_OP	"\t.half\t"
#undef TARGET_ASM_ALIGNED_SI_OP
#define TARGET_ASM_ALIGNED_SI_OP	"\t.word\t"
struct gcc_target targetm = TARGET_INITIALIZER;	// K{I

// ̃W[Ŏgp}NłB
#define WORD_ALIGN(SIZE)	(((SIZE) + 3) & ~3)

//zgɑSs\BǂʂŎĝ킩܂B
int
c33_num_arg_regs (int int_mode, tree type)
{
  enum machine_mode mode = (enum machine_mode) int_mode;
  int size;

  if (MUST_PASS_IN_STACK (mode, type))
    return 0;

  if (type && mode == BLKmode)
    size = int_size_in_bytes (type);
  else
    size = GET_MODE_SIZE (mode);

  return (size + UNITS_PER_WORD - 1) / UNITS_PER_WORD;
}

//print_operandprint_operand_addressǂŌĂѕ̂悭킩Ȃc
void
c33_print_operand(FILE* fp,  rtx x, int code)
{
	rtx x0;

	// ܂̂ƂA"%+R[h+l"`͎gĂ܂BiF"%A0"j
	// "%+l"`݂̂łBiF"%0"j
	// O҂̌`g悤ɂȂƂɂȂƂ܂B
	if(code != 0) {
		fprintf(stderr, "unknown code = %#x\n", code);
		debug_rtx(x);
		output_operand_lossage("c33_print_operand: unknown code");
		abort();
	}

	switch(GET_CODE(x)) {
	case REG:
		// uld.w %r0, %r1vȂ
		//        ~~~  ~~~
		if((unsigned)REGNO(x) >= ARRAY_SIZE(reg_names)) abort();
		fputs(reg_names[REGNO(x)], fp);
		return;
	case MEM:
		x0 = XEXP(x, 0);
		switch(GET_CODE(x0)) {
		case REG:
			// uxld.w %r0, [%r1]vȂ
			//              ~~~~~
			fprintf(fp, "[");
			if((unsigned)REGNO(x0) >= ARRAY_SIZE(reg_names)) abort();
			fputs(reg_names[REGNO(x0)], fp);
			fprintf(fp, "]");
			return;
		case PLUS:
			if(GET_CODE(XEXP(x0, 0)) == REG &&
			   GET_CODE(XEXP(x0, 1)) == CONST_INT) {
				// uxld.w %r0, [%r1+imm]vȂ
				//              ~~~~~~~~~
				fprintf(fp, "[");
				if((unsigned)REGNO(XEXP(x0, 0)) >= ARRAY_SIZE(reg_names)) abort();
				fprintf(fp, "%s+%d", reg_names[REGNO(XEXP(x0, 0))], INTVAL(XEXP(x0, 1)));
				fprintf(fp, "]");
				return;
			}
			fprintf(stderr, "bad INDEXed address:");
			debug_rtx(x0);
			output_operand_lossage("c33_print_operand: unhandled MEM-PLUS");
			abort();
		default:
			if(CONSTANT_ADDRESS_P(x0)) { // PSYMBOL_REFƂ͌܂I
				// uxld.w %r0, [SYMBOL+imm]vȂǁB
				//              ~~~~~~~~~~~~
				fprintf(fp, "[");
				output_addr_const(fp, x0);
				fprintf(fp, "]");
				return;
			}
			debug_rtx(x0);
			output_operand_lossage("c33_print_operand: unhandled MEM");
			abort();
		}
	default:
		// MEM̏ꍇƈāAłCONSTANT_ADDRESS_P(x)`FbN_I
		// output_addr_const()֗ȂĂ͂Ȃ悤łBiSHFR30Ă܂j
		// Ă݂ƂAIyhH(code_label "")ƂŌĂ΂邱Ƃ݂łB
		// output_addr_const()́AIyhPɖ悤ȑɂȂĂ̂ȁH
		output_addr_const(fp, x);
		return;
	}
}

void
c33_print_operand_address(FILE* fp, rtx addr)
{
	if(GET_CODE(addr) == SYMBOL_REF) {
		output_addr_const(fp, addr);
		return;
	}

	debug_rtx(addr);
	output_operand_lossage("c33_print_operand_address: unhandled addr");
	abort();
}

// ̃W[Ŏgp}NłB
#define MUST_SAVE_REGISTER(regno)								\
	(regno == FRAME_POINTER_REGNUM) ? (regs_ever_live[regno] || frame_pointer_needed  )	\
	                                : (regs_ever_live[regno] && !call_used_regs[regno])

void
c33_expand_prologue(void)
{
	int regno, size;

	/* WX^ޔBipushnRTXev[g̏킩Ȃ̂ŁAdȂЂƂÂj */
	for(regno = 0; regno <= FIRST_PSEUDO_REGISTER - 1; regno++) {
		if(MUST_SAVE_REGISTER(regno)) {
			emit_insn(gen_c33_push(gen_rtx_REG(SImode, regno)));
		}
	}

	/* X^bN蓖āBi[JϐƏo͈j */
	size = get_frame_size() + current_function_outgoing_args_size;
	if(size) emit_insn(gen_subsi3(stack_pointer_rtx, stack_pointer_rtx, GEN_INT(size)));

	/* t[|C^ݒB */
	if(frame_pointer_needed) emit_move_insn(frame_pointer_rtx, stack_pointer_rtx);
}

void
c33_expand_epilogue(void)
{
	int regno, size;

	/* X^bN|C^ݒB */
	if(frame_pointer_needed) emit_move_insn(stack_pointer_rtx, frame_pointer_rtx);

	/* X^bNJBi[JϐƏo͈j */
	size = get_frame_size() + current_function_outgoing_args_size;
	if(size) emit_insn(gen_addsi3(stack_pointer_rtx, stack_pointer_rtx, GEN_INT(size)));

	/* WX^BipopnRTXev[g̏킩Ȃ̂ŁAdȂЂƂÂj */
	for(regno = FIRST_PSEUDO_REGISTER - 1; regno >= 0; regno--) {
		if(MUST_SAVE_REGISTER(regno)) {
			emit_insn(gen_c33_pop(gen_rtx_REG(SImode, regno)));
		}
	}

	/* "ret"B */
	emit_insn(gen_c33_ret());
}

int
c33_initial_offset(int from, int to)
{
	int regno, size;

	if(from == FRAME_POINTER_REGNUM && to == STACK_POINTER_REGNUM) {
		return 0;
	}
	if((from == ARG_POINTER_REGNUM && to == FRAME_POINTER_REGNUM) ||
	   (from == ARG_POINTER_REGNUM && to == STACK_POINTER_REGNUM)) {
		size = 0;
		for(regno = 0; regno <= FIRST_PSEUDO_REGISTER - 1; regno++) {
			if(MUST_SAVE_REGISTER(regno)) size += 4;
		}
		size += get_frame_size() + current_function_outgoing_args_size;
		return size;
	}
	abort();
}

void
c33_asm_output_ascii(FILE* fp, const char* ptr, size_t len)
{
	size_t i, j;

	/* e\x??`ŏo͂̂ŁA1oCg4łB20oCg80ňsƂ邱Ƃɂ܂B
	 * as33̈s̕E160x݂łAÔ߂Ȃ菭Ȃ߂Ő؂邱Ƃɂ܂B
	 */
	for(i = 0; i < len; i += 20) {
		fputs("\t.ascii \"", asm_out_file);
		for(j = 0; j < 20; j++) {
			fprintf(asm_out_file, "\\x%02x", (unsigned char)*ptr++);
		}
		fputs("\"\n", asm_out_file);
	}
}
