//------------------------------------------------------------------------
 //  Project Name   :  ij
  //  File Name      :  PIECE_STD.c
   //  Copyright      :  AQUA (Leaf)  since 2001 - 
    //                                 Programd by.  Miyakusa Masakazu
     //------------------------------------------------------------------------
      // PIECEWCu


#ifdef _WIN32
	#include <windows.h>
	#include <mmsystem.h>
	#include <winnls32.h>
	#include <win_STD.h>
#else
#define __PCEKN__
	#include <piece.h>
	#include "system.h"
	#include "HM_mem.h"
#endif


#include "PIECE_Std.h"
#include "FilePack.h"

WORD	pceSinTable[32]={
	0x0000,	0x031f,	0x061f,	0x08e3,
	0x0b50,	0x0d4d,	0x0ec8,	0x0fb1,
	
	0x1000,	0x0fb1,	0x0ec8,	0x0d4d,
	0x0b50,	0x08e3,	0x061f,	0x031f,

	0x0000,	0xfce1,	0xf9e1,	0xf71d,
	0xf4b0,	0xf2b3,	0xf138,	0xf04f,
	
	0xf000,	0xf04f,	0xf138,	0xf2b3,
	0xf4b0,	0xf71d,	0xf9e1,	0xfce1,
};

void PIECE_TextConv( char *src )
{
	char	buf[256];
	char	*ptr=src;
	int		i=0;
	while( !(*src=='\0' || *src==' ')  ){
		if( *src==0x5c ){	//'\'
			buf[i++] = 0x5c;
		}
		buf[i++] = *src;
		src++;
	}
	buf[i] = '\0';
	strcpy( ptr, buf );
}

char *PIECE_StrTok( char *tok, char *deli )
{
	static char	*str=NULL;
	char		*ret;
	DWORD		len = strlen(deli);

	if(tok){
		str = tok;
	}
	if(!str) return NULL;
	ret = str;
	while( *str ){
		if( !PIECE_strcmp(str,deli) ){//f~^
			memset( str, 0, len );
			str+=len;
			return ret;
		}
		str++;
	}
	return ret;

}

BOOL memcpy2( void *dst, void *src, size_t count )
{
	DWORD	i;
	BYTE	*dst2 = (BYTE*)dst;
	BYTE	*src2 = (BYTE*)src;
	
	if(!dst2) return FALSE;
	if(!src2) return FALSE; 
	for( i=0; i<count ;i++, dst2++, src2++ ){
		*dst2 = *src2;
	}
	return TRUE;
}

BOOL memset2( void *dst, int c, size_t count )
{
	int	i;
	BYTE	*dst2 = (BYTE*)dst;
	
	if(!dst2) return FALSE;
	for( i=0; i<(signed)count ;i++, dst2++ ){
		*dst2 = c;
	}
	return TRUE;
}
//-------------------------------------------------------
//	BitǗ֐(1,2,4Ή)
//-------------------------------------------------------
BYTE PIECE_GetBit( BYTE *buf, int pich, int num )
{
	BYTE	mask = 0xff>>(8-pich);
	if( !(pich==1 || pich==2 || pich==4) ) return 0;

	buf += num*pich/8;
	return (*buf>>(8-pich-num*pich%8)) & mask;
}
//-------------------------------------------------------
//	BitǗ֐(1,2,4Ή)
//-------------------------------------------------------
BOOL PIECE_SetBit( BYTE *buf, int pich, int num, int src )
{
	BYTE	mask = 0xff>>(8-pich);
	if( !(pich==1 || pich==2 || pich==4) ) return FALSE;

	buf += num*pich/8;

	*buf &= ~(mask<<(8-pich-num*pich%8));
	*buf |= (src & mask)<<(8-pich-num*pich%8);
	return TRUE;
}



//-------------------------------------------------------
//	p啶Aɕϊ
//-------------------------------------------------------
void PIECE_strlower( char *dst, char *src )
{
	while( *src ){
		*(dst++) = (char)tolower( *(src++) );
	}
	*dst='\0';
}
//-------------------------------------------------------
//	pA啶ɕϊ
//-------------------------------------------------------
void PIECE_strupper( char *dst, char *src )
{
	while( *src ){
		*(dst++) = (char)toupper( *(src++) );
	}
	*dst='\0';
}
//-------------------------------------------------------
//	񂩂炠R[hA܂ł̕擾
//-------------------------------------------------------
int	PIECE_strtok( char *dst, char *src, unsigned long code )
{
	int			i=0;
	static BYTE	*src2=NULL;
	if(src)	src2 = (BYTE *)src;

	if(code>0xff){
		code = ( (code>>8)|(code<<8) )&0xffff;
		while( *src2 ){
			if( *(WORD*)src2==code ){
				break;
			}
			i++;
			if(dst)	*dst++ = *src2++;
			else	src2++;
		}
		if(dst)	*dst='\0';
	}else{
		while( *src2 ){
			if( *src2==code ){
				break;
			}
			i++;
			if(dst)	*dst++ = *src2++;
			else	src2++;
		}
		if(dst)	*dst='\0';
	}
	return i;
}

//-------------------------------------------------------
//	rimtkk𖳎j
//-------------------------------------------------------
int	PIECE_strcmp( char *str1, char *str2 )
{
	int	len = strlen( str2 );
	int	i,count=0;

	for(i=0;i<len;i++){
		if( *(str1+i) != *(str2+i) ){
			count++;
		}
	}
	return count;
}
//-------------------------------------------------------
//	riPɕQ܂܂Ă΁A^j
//-------------------------------------------------------
int	PIECE_strcmp2( char *str1, char *str2 )
{
	int	i;
	int	len1 = strlen( str1 );
	int	len2 = strlen( str2 );
	int	ret=1;

	i=0;
	while( strncmp( str1, str2, len2 ) ){
		str1++; i++;
		if(i+len2>len1){
			ret=0;
			break;
		}
	}
	
	return ret;
}
//-------------------------------------------------------
//	rimtkk𖳎j
//-------------------------------------------------------
int	PIECE_strcmpUL( char *str1, char *str2 )
{
	char	buf1[256], buf2[256];
	PIECE_strlower( buf1, str1 );
	PIECE_strlower( buf2, str2 );
	return strcmp( buf1, buf2 );
}

//-------------------------------------------------------
//	PCMĐ
//-------------------------------------------------------
#ifndef _WIN32
static PCEWAVEINFO	PceWaveInfo[4];

static BOOL PIECE_PlayPcmBuffer( int ch, unsigned char *buf )
{
	DWORD		size;

	ch = min( max(ch,0), 3 );
	if( buf==NULL ) return FALSE;
	if( *(DWORD*)buf != DWORD_CHAR('P','P','C','M') ) return FALSE;
	if( pceWaveCheckBuffs(ch) ) return FALSE;

	buf+=4;
	size = *(DWORD*)buf;	//TCY擾
	buf+=4;
	memcpy2( &PceWaveInfo[ch], buf, sizeof(PCEWAVEINFO) );
	buf+=sizeof(PCEWAVEINFO);

	PceWaveInfo[ch].len       = size;			// 0  Xe[^X
	PceWaveInfo[ch].stat      = PW_STAT_START;	// 0  Xe[^X
	PceWaveInfo[ch].pData     = buf;			// 4  f[^ւ̃|C^
	PceWaveInfo[ch].pfEndProc = NULL;			// 16 IR[obN
	
	pceWaveAbort( ch );
	pceWaveDataOut( ch, &PceWaveInfo[ch] );
	return TRUE;
}	
#endif

typedef struct{
	int	stop;	//~tOA0FĐ@1:~
	int	mus_no;	//Đ̋ȔԁF-1͍ĐȂ
	int	vol;	//0-127
	int	loop;	//[vݒ(gp)
}MUSIC_CONTROL;
#define MUS_CH	0

static MUSIC_CONTROL	MusCtl = {0,-1,0,1};
	
//
BOOL PIECE_PlayPcm( char *fname )
{
#ifdef _WIN32
/*
	BYTE	PCM_Table[16]={
		 47,  61,  74,  86,  97, 107, 116, 124,
		131, 139, 148, 158, 169, 181, 194, 208
	};
	BYTE	*buf=NULL;
	char	fn[256];
	int		count=0, i, j, work, tno=0;
	DWORD	size;
	BYTE	*newbuf=NULL;


	wsprintf( fn, "pcm\\%s", fname );
	STD_ReadFileMax( fn, &buf );

	count+=4;
	size = *(DWORD*)(buf+count);
	count+=20;
	newbuf = GAlloc( size/2 );

	for(i=0;i<size;i++){
		work=999;
		for(j=0;j<16;j++){
			if( ABS( buf[count]-PCM_Table[j] ) < work ){
				work = ABS( buf[count+i]-PCM_Table[j] );
				tno = j;
			}
		}
		STD_SetBit( newbuf, 4, i, tno );
	}

	STD_WriteFile( "pcm\\_________.ppd", (char *)buf, 28 );
	STD_WriteFilePos( "pcm\\_________.ppd", (char *)newbuf, 28, size/2 );

	GFree(buf);
	GFree(newbuf);
	char	buf[256];
	wsprintf( buf, "pcm\\16K_8BIT\\%s", fname );
	STD_FileAttrChange( buf, NULL, "wav" );
	return PlaySound( buf, NULL, SND_FILENAME|SND_ASYNC );
*/
	return TRUE;
#else
	if( !MusCtl.stop ){
		int	i=1;
		while(i<4){
			if( !pceWaveCheckBuffs(i) ){
				if( PIECE_PlayPcmBuffer( i, FPK_FindPackData( PCM, fname ) ) ){
					break;
				}
			}
			i++;
		}
	}
#endif
	return TRUE;
}

//
BOOL PIECE_PlayMusic( int mus_no, int loop )
{
	char	buf[16];

	if(MusCtl.mus_no==mus_no) return TRUE;
	MusCtl.mus_no = mus_no;
	MusCtl.loop = loop;//gp

#ifndef _WIN32
	if(mus_no==-1){
		pceWaveAbort( MUS_CH );
	}else{
		if(!MusCtl.stop){
			pceWaveAbort( MUS_CH );
			pcesprintf( buf, "mus_%03d.pmd", mus_no );
			PlayMusic( FPK_FindPackData( MUS, buf ) );
//			PlayMusic( FPK_FindPackData( MUS, "mus_001.pmd" ) );
		}
	}
#endif
	return TRUE;
}
//Ȃ̒~ON/OFF
//iĐȂ𖳂ɐݒ肷ꍇ́APIECE_PlayMusic(-1)gj
BOOL PIECE_StopMusic( int flag )
{
	char	buf[16];
#ifndef _WIN32
	MusCtl.stop=flag;
	if(flag){	//~
		pceWaveAbort( MUS_CH );
	}else{		//~̕A
		if(MusCtl.mus_no!=-1){
			pceWaveAbort( MUS_CH );
			pcesprintf( buf, "mus_%03d.pmd", MusCtl.mus_no );
			PlayMusic( FPK_FindPackData( MUS, buf ) );
		}
	}
#endif
	return TRUE;
}
//
BOOL PIECE_MusicVol( int att )
{
	MusCtl.vol = att;
#ifndef _WIN32
	pceWaveSetChAtt( MUS_CH, att );//INVALIDVAL
#endif
	return TRUE;
}




//////////////////////////////////////////
#ifndef _WIN32

int pceFileReadPos( FILEACC *pfa, unsigned char *buf, int pos, int size )
{
	int		work=pos;
	int		size2=0;

	if(pos%4096){
		pceFileReadSct( pfa, NULL, work/4096, 4096 );
		size2 += memcpy( buf, pfa->aptr+pos%4096, min( 4096-pos%4096, size) );
		work += min( 4096-pos%4096, size);
	}
	while( pos+size > work ){
		pceFileReadSct( pfa, NULL, work/4096, min( pos+size-work,4096) );
		size2 += memcpy( buf+(work-pos), pfa->aptr, min( pos+size-work,4096) );
		work+=4096;
	}

	return size2;
}

unsigned long PIECE_FileReadMax( char *fname, unsigned char *buf )
{
	FILEACC			pfa;
	unsigned long	size2;

	if( pceFileOpen( &pfa, fname, FOMD_RD ) ) return FALSE;
	size2 = pceFileReadPos( &pfa, buf, 0, pfa.fsize );
	pceFileClose( &pfa );
	return TRUE;
}

#endif
//////////////////////////////////////////






enum{
	IR_NOIR,	//ҋ@ԁiftHgj
	IR_GET,		//M+҂
	IR_SEND,	//M
	IR_SENDWAIT,//M҂
};

typedef struct{
	unsigned char	send_data[IR_SENDMAX+4];
	unsigned char	get_data[IR_SENDMAX+4];
	char			step;
	char			err;	//f[^G[tO@OFM@OȊOFMs
	char			damy[2];
}IR_CONTROL;

static IR_CONTROL	IrCtl;

//
BOOL PIECE_InitIR( void )
{
#ifndef _WIN32
	pceIRStartTx( IrCtl.send_data, 4 );//Ƃ肠AȂ񂩑MȂƎMłȂ̂
	IrCtl.step = IR_GET;
	IrCtl.err  = 1;		//̎Mobt@͐ł͂Ȃ
#endif
	return TRUE;
}
//
BOOL PIECE_TermIR( void )
{
#ifndef _WIN32
	pceIRStop();
	IrCtl.step = IR_NOIR;
#endif
	return TRUE;
}
//
BOOL PIECE_IR_SendData( unsigned char *send )
{
#ifndef _WIN32
	if(IrCtl.step==IR_SENDWAIT) return FALSE;
	IrCtl.step = IR_SEND;
	memcpy( IrCtl.send_data+4, send, IR_SENDMAX );
#endif
	return TRUE;
}
//
unsigned char *PIECE_IR_GetData( void )
{
#ifndef _WIN32
	if(IrCtl.err)	return NULL;
	else{
		IrCtl.err=1;//f[^̎擾͈x
		return IrCtl.get_data+4;
	}
#else
	return NULL;
#endif
}
//
void PIECE_IRProc( void )
{
#ifndef _WIN32
	char	flag;
	switch(IrCtl.step){
		default:
		case IR_NOIR:
			break;
		case IR_GET://Mor҂
			if( !pceIRGetStat() ){
				pceIRStartRx( IrCtl.get_data, IR_SENDMAX+4 );
				
				pceCRC32( 0,0 );
				IrCtl.err = (*(DWORD*)IrCtl.get_data != pceCRC32(IrCtl.get_data+4,IR_SENDMAX));
			}else{
//				PDW_SetDrawText( &dobj[29], "Mҋ@",  0, 0, 10, COLOR_BLACK, TRUE, 10 );
			}
			break;
		case IR_SEND://M
			pceCRC32( 0,0 );
			*(DWORD*)IrCtl.send_data = pceCRC32( IrCtl.send_data+4, IR_SENDMAX );
			pceIRStartTx( IrCtl.send_data, IR_SENDMAX+4 );
			IrCtl.step=IR_SENDWAIT;
			break;
		case IR_SENDWAIT://M҂
			if( !pceIRGetStat() ){
//				PDW_SetDrawText( &dobj[30], "M[[I",  0, 0, 10, COLOR_BLACK, TRUE, 10 );
				IrCtl.step = IR_GET;
			}else{
//				PDW_SetDrawText( &dobj[30], "Mҋ@",  0, 0, 10, COLOR_BLACK, TRUE, 10 );
			}
			break;
	}
#endif
}
